/*******************(C) COPYRIGHT 2022 Masses-Chip ******************************
*Project Name        : M8P615_ADC.prj
* File Name          : ADC_WORK.C
* Author             : MASSES CHIP
* Version            : V1.03
* Date               : 2021/10/20
;* Web    			 : www.masses-chip.com
;* FAE               : Luo
;  				 	 : QQ：411680975
********************************************************************************
*说明：本范例是输入通道AN0(IOA0)的AD(时钟FCPU 参考电压VDD)采集
连续采十次AD数据去掉最大最小值求平均得出AD值
*******************************************************************************/

#include "ZC.h"
#include "MASSESCHIP_DEFINE.H"

unsigned	int	ADC_Temp;
unsigned  	int	ADC_MAX_DATA;
unsigned  	int	ADC_MIN_DATA;
unsigned  	int	ADC_DATA_Sum;


//*****************************************************************
//取十次的值，去除最大值最小值，剩下的求平均值
//*****************************************************************
void  ADC_DATA_Real(void)
{
	uchar	i;
	ADC_MIN_DATA = 0xFFFF;				 		//最小值赋值
	ADC_MAX_DATA = 0x0000;				 		//最大值赋值
	ADC_DATA_Sum = 0x0000;	
	for(i = 0; i < 10; i++)
	{   
		ADS = 1;								//AD转换
		while(ADS==1);				
		ADC_Temp = ADH;
		ADC_Temp = ADC_Temp << 8;
		ADC_Temp = ADC_Temp + ADL;
		ADC_DATA_Sum = ADC_DATA_Sum + ADC_Temp; //累加ADC测量数据		
		if(ADC_Temp > ADC_MAX_DATA)	     		//判断最大值
		{
			ADC_MAX_DATA = ADC_Temp;		
		}		
		if(ADC_Temp < ADC_MIN_DATA)	     		//判断最小值	
		{
			ADC_MIN_DATA = ADC_Temp;
		}	
	}
	ADC_DATA_Sum = ADC_DATA_Sum - ADC_MAX_DATA - ADC_MIN_DATA;
	ADC_DATA_Sum = ADC_DATA_Sum >> 3;			//剩下8组数据平均
}
